﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Xamarin.Forms;

namespace SampleDemo
{
    public class OrderCell : ViewCell
    {
        #region Constructor

        public OrderCell()
        {
            this.View = InitializeTemplate();
        }

        #endregion

        #region CustomTemplate

        private Grid InitializeTemplate()
        {
            var maingrid = new Grid();
            var row0 = new RowDefinition { Height = new GridLength(1, GridUnitType.Star) };
            var row1 = new RowDefinition { Height = 1 };
            maingrid.RowDefinitions.Add(row0);
            maingrid.RowDefinitions.Add(row1);
            maingrid.RowSpacing = 1;

            var grid = new Grid();
            var column0 = new ColumnDefinition { Width = new GridLength(1, GridUnitType.Star) };
            var column1 = new ColumnDefinition { Width = new GridLength(1, GridUnitType.Star) };
            grid.ColumnDefinitions.Add(column0);
            grid.ColumnDefinitions.Add(column1);

            var customerId = new Label();
            customerId.SetBinding(Label.TextProperty, new Binding("ID"));
            customerId.LineBreakMode = LineBreakMode.NoWrap;
            customerId.FontAttributes = FontAttributes.Bold;
            customerId.TextColor = Color.White;
            customerId.FontSize = 18;

            var customerName = new Label();
            customerName.FontAttributes = FontAttributes.None;
            customerName.FontSize = 18;
            customerName.LineBreakMode = LineBreakMode.NoWrap;
            customerName.SetBinding(Label.TextProperty, new Binding("Name"));
            customerName.TextColor = Color.White;

            grid.Children.Add(customerId, 0, 0);
            grid.Children.Add(customerName, 1, 0);

            var stacklayout = new StackLayout();
            stacklayout.HeightRequest = 1;
            stacklayout.BackgroundColor = Color.Gray;
            maingrid.Children.Add(grid);
            maingrid.Children.Add(stacklayout, 0, 1);
            return maingrid;
        }

        #endregion
    }
}
