﻿using Syncfusion.DataSource;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using Xamarin.Forms;
using Xamarin.Forms.Xaml;

namespace SampleDemo
{
    public partial class MainPage : ContentPage
    {
        #region Constructor

        public MainPage()
        {
            InitializeComponent();
            listView.ItemTemplate = new DataTemplate(typeof(OrderCell));
            listView.ItemSize = 60;
            listView.ItemsSource = viewModel.OrderItemCollection;
            listView.DataSource.SortDescriptors.Add(new SortDescriptor()
            {
                PropertyName = "ID",
                Direction = ListSortDirection.Ascending,
            });
        }

        #endregion

        #region Private Methods

        private bool FilterOrders(object obj)
        {
            if (searchBar == null || searchBar.Text == null)
                return true;

            var order = obj as OrderItem;
            if (order.ID.Equals(searchBar.Text.ToLower())
                || order.Name.ToLower().Contains(searchBar.Text.ToLower()))
                return true;
            else
                return false;
        }

        #endregion

        #region CallBacks

        SearchBar searchBar = null;
        private void OnFilterTextChanged(object sender, TextChangedEventArgs e)
        {
            searchBar = (sender as SearchBar);
            if (listView.DataSource != null)
            {
                this.listView.DataSource.Filter = FilterOrders;
                this.listView.DataSource.RefreshFilter();
            }
        }

        #endregion
    }
}
